// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: driver.proto

/*
	Package protocol is a generated protocol buffer package.

	It is generated from these files:
		driver.proto

	It has these top-level messages:
		ParseRequest
		ParseResponse
		ParseError
		Version
		Manifest
		VersionRequest
		VersionResponse
		SupportedLanguagesRequest
		SupportedLanguagesResponse
*/
package protocol

import proto "github.com/gogo/protobuf/proto"
import fmt "fmt"
import math "math"
import _ "github.com/gogo/protobuf/gogoproto"
import _ "github.com/golang/protobuf/ptypes/timestamp"

import time "time"

import context "golang.org/x/net/context"
import grpc "google.golang.org/grpc"

import types "github.com/gogo/protobuf/types"

import io "io"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf
var _ = time.Kitchen

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion2 // please upgrade the proto package

type Mode int32

const (
	// DefaultMode selects the transformation mode that is considered to produce UAST of the best quality.
	Mode_DefaultMode Mode = 0
	// Native disables any UAST transformations and emits a native language AST as returned by the parser.
	Mode_Native Mode = 1
	// Preprocessed runs only basic transformation over native AST (normalize positional info, type fields).
	Mode_Preprocessed Mode = 2
	// Annotated UAST is based on native AST, but provides role annotations for nodes.
	Mode_Annotated Mode = 4
	// Semantic UAST normalizes native AST nodes to a unified structure where possible.
	Mode_Semantic Mode = 8
)

var Mode_name = map[int32]string{
	0: "DEFAULT_MODE",
	1: "NATIVE",
	2: "PREPROCESSED",
	4: "ANNOTATED",
	8: "SEMANTIC",
}
var Mode_value = map[string]int32{
	"DEFAULT_MODE": 0,
	"NATIVE":       1,
	"PREPROCESSED": 2,
	"ANNOTATED":    4,
	"SEMANTIC":     8,
}

func (x Mode) String() string {
	return proto.EnumName(Mode_name, int32(x))
}
func (Mode) EnumDescriptor() ([]byte, []int) { return fileDescriptorDriver, []int{0} }

type DevelopmentStatus int32

const (
	DevelopmentStatus_Inactive DevelopmentStatus = 0
	DevelopmentStatus_Planning DevelopmentStatus = 1
	DevelopmentStatus_PreAlpha DevelopmentStatus = 2
	DevelopmentStatus_Alpha    DevelopmentStatus = 3
	DevelopmentStatus_Beta     DevelopmentStatus = 4
	DevelopmentStatus_Stable   DevelopmentStatus = 5
	DevelopmentStatus_Mature   DevelopmentStatus = 6
)

var DevelopmentStatus_name = map[int32]string{
	0: "DEV_INACTIVE",
	1: "DEV_PLANNING",
	2: "DEV_PREALPHA",
	3: "DEV_ALPHA",
	4: "DEV_BETA",
	5: "DEV_STABLE",
	6: "DEV_MATURE",
}
var DevelopmentStatus_value = map[string]int32{
	"DEV_INACTIVE": 0,
	"DEV_PLANNING": 1,
	"DEV_PREALPHA": 2,
	"DEV_ALPHA":    3,
	"DEV_BETA":     4,
	"DEV_STABLE":   5,
	"DEV_MATURE":   6,
}

func (x DevelopmentStatus) String() string {
	return proto.EnumName(DevelopmentStatus_name, int32(x))
}
func (DevelopmentStatus) EnumDescriptor() ([]byte, []int) { return fileDescriptorDriver, []int{1} }

// ParseRequest is a request to parse a file and get its UAST.
type ParseRequest struct {
	// Content stores the content of a source file. Required.
	Content string `protobuf:"bytes,1,opt,name=content,proto3" json:"content,omitempty"`
	// Language can be set optionally to disable automatic language detection.
	Language string `protobuf:"bytes,2,opt,name=language,proto3" json:"language,omitempty"`
	// Filename can be set optionally to assist automatic language detection.
	Filename string `protobuf:"bytes,3,opt,name=filename,proto3" json:"filename,omitempty"`
	// Mode sets a transformation pipeline used for UAST.
	Mode Mode `protobuf:"varint,4,opt,name=mode,proto3,enum=gopkg.in.bblfsh.sdk.v2.protocol.Mode" json:"mode,omitempty"`
}

func (m *ParseRequest) Reset()                    { *m = ParseRequest{} }
func (m *ParseRequest) String() string            { return proto.CompactTextString(m) }
func (*ParseRequest) ProtoMessage()               {}
func (*ParseRequest) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{0} }

// ParseResponse is the reply to ParseRequest.
type ParseResponse struct {
	// UAST is a binary encoding of the resulting UAST.
	Uast []byte `protobuf:"bytes,1,opt,name=uast,proto3" json:"uast,omitempty"`
	// Language that was automatically detected.
	Language string `protobuf:"bytes,2,opt,name=language,proto3" json:"language,omitempty"`
	// Errors is a list of parsing errors.
	// Only set if parser was able to return a response. Otherwise gRPC error codes are used.
	Errors []*ParseError `protobuf:"bytes,3,rep,name=errors" json:"errors,omitempty"`
}

func (m *ParseResponse) Reset()                    { *m = ParseResponse{} }
func (m *ParseResponse) String() string            { return proto.CompactTextString(m) }
func (*ParseResponse) ProtoMessage()               {}
func (*ParseResponse) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{1} }

type ParseError struct {
	// Text is an error message.
	Text string `protobuf:"bytes,1,opt,name=text,proto3" json:"text,omitempty"`
}

func (m *ParseError) Reset()                    { *m = ParseError{} }
func (m *ParseError) String() string            { return proto.CompactTextString(m) }
func (*ParseError) ProtoMessage()               {}
func (*ParseError) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{2} }

type Version struct {
	Version string    `protobuf:"bytes,1,opt,name=version,proto3" json:"version,omitempty"`
	Build   time.Time `protobuf:"bytes,2,opt,name=build,stdtime" json:"build"`
}

func (m *Version) Reset()                    { *m = Version{} }
func (m *Version) String() string            { return proto.CompactTextString(m) }
func (*Version) ProtoMessage()               {}
func (*Version) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{3} }

type Manifest struct {
	// Name is a human-readable language or driver name.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Language is a Babelfish language identifier.
	Language string `protobuf:"bytes,2,opt,name=language,proto3" json:"language,omitempty"`
	// Aliases is a list of alternative language identifiers from Enry/Linguist.
	Aliases []string `protobuf:"bytes,3,rep,name=aliases" json:"aliases,omitempty"`
	// Version of the language driver.
	Version *Version `protobuf:"bytes,4,opt,name=version" json:"version,omitempty"`
	// Status of the driver development.
	Status DevelopmentStatus `protobuf:"varint,5,opt,name=status,proto3,enum=gopkg.in.bblfsh.sdk.v2.protocol.DevelopmentStatus" json:"status,omitempty"`
	// Features this driver supports.
	Features []string `protobuf:"bytes,6,rep,name=features" json:"features,omitempty"`
}

func (m *Manifest) Reset()                    { *m = Manifest{} }
func (m *Manifest) String() string            { return proto.CompactTextString(m) }
func (*Manifest) ProtoMessage()               {}
func (*Manifest) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{4} }

type VersionRequest struct {
}

func (m *VersionRequest) Reset()                    { *m = VersionRequest{} }
func (m *VersionRequest) String() string            { return proto.CompactTextString(m) }
func (*VersionRequest) ProtoMessage()               {}
func (*VersionRequest) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{5} }

type VersionResponse struct {
	Version *Version `protobuf:"bytes,1,opt,name=version" json:"version,omitempty"`
}

func (m *VersionResponse) Reset()                    { *m = VersionResponse{} }
func (m *VersionResponse) String() string            { return proto.CompactTextString(m) }
func (*VersionResponse) ProtoMessage()               {}
func (*VersionResponse) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{6} }

type SupportedLanguagesRequest struct {
}

func (m *SupportedLanguagesRequest) Reset()                    { *m = SupportedLanguagesRequest{} }
func (m *SupportedLanguagesRequest) String() string            { return proto.CompactTextString(m) }
func (*SupportedLanguagesRequest) ProtoMessage()               {}
func (*SupportedLanguagesRequest) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{7} }

type SupportedLanguagesResponse struct {
	// Languages is a list of driver manifests for each language supported by the server.
	Languages []*Manifest `protobuf:"bytes,1,rep,name=languages" json:"languages,omitempty"`
}

func (m *SupportedLanguagesResponse) Reset()                    { *m = SupportedLanguagesResponse{} }
func (m *SupportedLanguagesResponse) String() string            { return proto.CompactTextString(m) }
func (*SupportedLanguagesResponse) ProtoMessage()               {}
func (*SupportedLanguagesResponse) Descriptor() ([]byte, []int) { return fileDescriptorDriver, []int{8} }

func init() {
	proto.RegisterType((*ParseRequest)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.ParseRequest")
	proto.RegisterType((*ParseResponse)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.ParseResponse")
	proto.RegisterType((*ParseError)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.ParseError")
	proto.RegisterType((*Version)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.Version")
	proto.RegisterType((*Manifest)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.Manifest")
	proto.RegisterType((*VersionRequest)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.VersionRequest")
	proto.RegisterType((*VersionResponse)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.VersionResponse")
	proto.RegisterType((*SupportedLanguagesRequest)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.SupportedLanguagesRequest")
	proto.RegisterType((*SupportedLanguagesResponse)(nil), "gopkg.in.bblfsh.sdk.v2.protocol.SupportedLanguagesResponse")
	proto.RegisterEnum("gopkg.in.bblfsh.sdk.v2.protocol.Mode", Mode_name, Mode_value)
	proto.RegisterEnum("gopkg.in.bblfsh.sdk.v2.protocol.DevelopmentStatus", DevelopmentStatus_name, DevelopmentStatus_value)
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for Driver service

type DriverClient interface {
	// Parse returns an UAST for a given source file.
	Parse(ctx context.Context, in *ParseRequest, opts ...grpc.CallOption) (*ParseResponse, error)
}

type driverClient struct {
	cc *grpc.ClientConn
}

func NewDriverClient(cc *grpc.ClientConn) DriverClient {
	return &driverClient{cc}
}

func (c *driverClient) Parse(ctx context.Context, in *ParseRequest, opts ...grpc.CallOption) (*ParseResponse, error) {
	out := new(ParseResponse)
	err := grpc.Invoke(ctx, "/gopkg.in.bblfsh.sdk.v2.protocol.Driver/Parse", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Driver service

type DriverServer interface {
	// Parse returns an UAST for a given source file.
	Parse(context.Context, *ParseRequest) (*ParseResponse, error)
}

func RegisterDriverServer(s *grpc.Server, srv DriverServer) {
	s.RegisterService(&_Driver_serviceDesc, srv)
}

func _Driver_Parse_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ParseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DriverServer).Parse(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/gopkg.in.bblfsh.sdk.v2.protocol.Driver/Parse",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DriverServer).Parse(ctx, req.(*ParseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _Driver_serviceDesc = grpc.ServiceDesc{
	ServiceName: "gopkg.in.bblfsh.sdk.v2.protocol.Driver",
	HandlerType: (*DriverServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Parse",
			Handler:    _Driver_Parse_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "driver.proto",
}

// Client API for DriverHost service

type DriverHostClient interface {
	// ServerVersion returns version information of this server.
	ServerVersion(ctx context.Context, in *VersionRequest, opts ...grpc.CallOption) (*VersionResponse, error)
	// SupportedLanguages returns a list of languages supported by the server.
	SupportedLanguages(ctx context.Context, in *SupportedLanguagesRequest, opts ...grpc.CallOption) (*SupportedLanguagesResponse, error)
}

type driverHostClient struct {
	cc *grpc.ClientConn
}

func NewDriverHostClient(cc *grpc.ClientConn) DriverHostClient {
	return &driverHostClient{cc}
}

func (c *driverHostClient) ServerVersion(ctx context.Context, in *VersionRequest, opts ...grpc.CallOption) (*VersionResponse, error) {
	out := new(VersionResponse)
	err := grpc.Invoke(ctx, "/gopkg.in.bblfsh.sdk.v2.protocol.DriverHost/ServerVersion", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *driverHostClient) SupportedLanguages(ctx context.Context, in *SupportedLanguagesRequest, opts ...grpc.CallOption) (*SupportedLanguagesResponse, error) {
	out := new(SupportedLanguagesResponse)
	err := grpc.Invoke(ctx, "/gopkg.in.bblfsh.sdk.v2.protocol.DriverHost/SupportedLanguages", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for DriverHost service

type DriverHostServer interface {
	// ServerVersion returns version information of this server.
	ServerVersion(context.Context, *VersionRequest) (*VersionResponse, error)
	// SupportedLanguages returns a list of languages supported by the server.
	SupportedLanguages(context.Context, *SupportedLanguagesRequest) (*SupportedLanguagesResponse, error)
}

func RegisterDriverHostServer(s *grpc.Server, srv DriverHostServer) {
	s.RegisterService(&_DriverHost_serviceDesc, srv)
}

func _DriverHost_ServerVersion_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VersionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DriverHostServer).ServerVersion(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/gopkg.in.bblfsh.sdk.v2.protocol.DriverHost/ServerVersion",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DriverHostServer).ServerVersion(ctx, req.(*VersionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _DriverHost_SupportedLanguages_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SupportedLanguagesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DriverHostServer).SupportedLanguages(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/gopkg.in.bblfsh.sdk.v2.protocol.DriverHost/SupportedLanguages",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DriverHostServer).SupportedLanguages(ctx, req.(*SupportedLanguagesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _DriverHost_serviceDesc = grpc.ServiceDesc{
	ServiceName: "gopkg.in.bblfsh.sdk.v2.protocol.DriverHost",
	HandlerType: (*DriverHostServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ServerVersion",
			Handler:    _DriverHost_ServerVersion_Handler,
		},
		{
			MethodName: "SupportedLanguages",
			Handler:    _DriverHost_SupportedLanguages_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "driver.proto",
}

func (m *ParseRequest) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ParseRequest) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if len(m.Content) > 0 {
		dAtA[i] = 0xa
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Content)))
		i += copy(dAtA[i:], m.Content)
	}
	if len(m.Language) > 0 {
		dAtA[i] = 0x12
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Language)))
		i += copy(dAtA[i:], m.Language)
	}
	if len(m.Filename) > 0 {
		dAtA[i] = 0x1a
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Filename)))
		i += copy(dAtA[i:], m.Filename)
	}
	if m.Mode != 0 {
		dAtA[i] = 0x20
		i++
		i = encodeVarintDriver(dAtA, i, uint64(m.Mode))
	}
	return i, nil
}

func (m *ParseResponse) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ParseResponse) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if len(m.Uast) > 0 {
		dAtA[i] = 0xa
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Uast)))
		i += copy(dAtA[i:], m.Uast)
	}
	if len(m.Language) > 0 {
		dAtA[i] = 0x12
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Language)))
		i += copy(dAtA[i:], m.Language)
	}
	if len(m.Errors) > 0 {
		for _, msg := range m.Errors {
			dAtA[i] = 0x1a
			i++
			i = encodeVarintDriver(dAtA, i, uint64(msg.ProtoSize()))
			n, err := msg.MarshalTo(dAtA[i:])
			if err != nil {
				return 0, err
			}
			i += n
		}
	}
	return i, nil
}

func (m *ParseError) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ParseError) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if len(m.Text) > 0 {
		dAtA[i] = 0xa
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Text)))
		i += copy(dAtA[i:], m.Text)
	}
	return i, nil
}

func (m *Version) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Version) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if len(m.Version) > 0 {
		dAtA[i] = 0xa
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Version)))
		i += copy(dAtA[i:], m.Version)
	}
	dAtA[i] = 0x12
	i++
	i = encodeVarintDriver(dAtA, i, uint64(types.SizeOfStdTime(m.Build)))
	n1, err := types.StdTimeMarshalTo(m.Build, dAtA[i:])
	if err != nil {
		return 0, err
	}
	i += n1
	return i, nil
}

func (m *Manifest) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Manifest) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if len(m.Name) > 0 {
		dAtA[i] = 0xa
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Name)))
		i += copy(dAtA[i:], m.Name)
	}
	if len(m.Language) > 0 {
		dAtA[i] = 0x12
		i++
		i = encodeVarintDriver(dAtA, i, uint64(len(m.Language)))
		i += copy(dAtA[i:], m.Language)
	}
	if len(m.Aliases) > 0 {
		for _, s := range m.Aliases {
			dAtA[i] = 0x1a
			i++
			l = len(s)
			for l >= 1<<7 {
				dAtA[i] = uint8(uint64(l)&0x7f | 0x80)
				l >>= 7
				i++
			}
			dAtA[i] = uint8(l)
			i++
			i += copy(dAtA[i:], s)
		}
	}
	if m.Version != nil {
		dAtA[i] = 0x22
		i++
		i = encodeVarintDriver(dAtA, i, uint64(m.Version.ProtoSize()))
		n2, err := m.Version.MarshalTo(dAtA[i:])
		if err != nil {
			return 0, err
		}
		i += n2
	}
	if m.Status != 0 {
		dAtA[i] = 0x28
		i++
		i = encodeVarintDriver(dAtA, i, uint64(m.Status))
	}
	if len(m.Features) > 0 {
		for _, s := range m.Features {
			dAtA[i] = 0x32
			i++
			l = len(s)
			for l >= 1<<7 {
				dAtA[i] = uint8(uint64(l)&0x7f | 0x80)
				l >>= 7
				i++
			}
			dAtA[i] = uint8(l)
			i++
			i += copy(dAtA[i:], s)
		}
	}
	return i, nil
}

func (m *VersionRequest) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *VersionRequest) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	return i, nil
}

func (m *VersionResponse) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *VersionResponse) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if m.Version != nil {
		dAtA[i] = 0xa
		i++
		i = encodeVarintDriver(dAtA, i, uint64(m.Version.ProtoSize()))
		n3, err := m.Version.MarshalTo(dAtA[i:])
		if err != nil {
			return 0, err
		}
		i += n3
	}
	return i, nil
}

func (m *SupportedLanguagesRequest) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *SupportedLanguagesRequest) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	return i, nil
}

func (m *SupportedLanguagesResponse) Marshal() (dAtA []byte, err error) {
	size := m.ProtoSize()
	dAtA = make([]byte, size)
	n, err := m.MarshalTo(dAtA)
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *SupportedLanguagesResponse) MarshalTo(dAtA []byte) (int, error) {
	var i int
	_ = i
	var l int
	_ = l
	if len(m.Languages) > 0 {
		for _, msg := range m.Languages {
			dAtA[i] = 0xa
			i++
			i = encodeVarintDriver(dAtA, i, uint64(msg.ProtoSize()))
			n, err := msg.MarshalTo(dAtA[i:])
			if err != nil {
				return 0, err
			}
			i += n
		}
	}
	return i, nil
}

func encodeVarintDriver(dAtA []byte, offset int, v uint64) int {
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return offset + 1
}
func (m *ParseRequest) ProtoSize() (n int) {
	var l int
	_ = l
	l = len(m.Content)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	l = len(m.Language)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	l = len(m.Filename)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	if m.Mode != 0 {
		n += 1 + sovDriver(uint64(m.Mode))
	}
	return n
}

func (m *ParseResponse) ProtoSize() (n int) {
	var l int
	_ = l
	l = len(m.Uast)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	l = len(m.Language)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	if len(m.Errors) > 0 {
		for _, e := range m.Errors {
			l = e.ProtoSize()
			n += 1 + l + sovDriver(uint64(l))
		}
	}
	return n
}

func (m *ParseError) ProtoSize() (n int) {
	var l int
	_ = l
	l = len(m.Text)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	return n
}

func (m *Version) ProtoSize() (n int) {
	var l int
	_ = l
	l = len(m.Version)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	l = types.SizeOfStdTime(m.Build)
	n += 1 + l + sovDriver(uint64(l))
	return n
}

func (m *Manifest) ProtoSize() (n int) {
	var l int
	_ = l
	l = len(m.Name)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	l = len(m.Language)
	if l > 0 {
		n += 1 + l + sovDriver(uint64(l))
	}
	if len(m.Aliases) > 0 {
		for _, s := range m.Aliases {
			l = len(s)
			n += 1 + l + sovDriver(uint64(l))
		}
	}
	if m.Version != nil {
		l = m.Version.ProtoSize()
		n += 1 + l + sovDriver(uint64(l))
	}
	if m.Status != 0 {
		n += 1 + sovDriver(uint64(m.Status))
	}
	if len(m.Features) > 0 {
		for _, s := range m.Features {
			l = len(s)
			n += 1 + l + sovDriver(uint64(l))
		}
	}
	return n
}

func (m *VersionRequest) ProtoSize() (n int) {
	var l int
	_ = l
	return n
}

func (m *VersionResponse) ProtoSize() (n int) {
	var l int
	_ = l
	if m.Version != nil {
		l = m.Version.ProtoSize()
		n += 1 + l + sovDriver(uint64(l))
	}
	return n
}

func (m *SupportedLanguagesRequest) ProtoSize() (n int) {
	var l int
	_ = l
	return n
}

func (m *SupportedLanguagesResponse) ProtoSize() (n int) {
	var l int
	_ = l
	if len(m.Languages) > 0 {
		for _, e := range m.Languages {
			l = e.ProtoSize()
			n += 1 + l + sovDriver(uint64(l))
		}
	}
	return n
}

func sovDriver(x uint64) (n int) {
	for {
		n++
		x >>= 7
		if x == 0 {
			break
		}
	}
	return n
}
func sozDriver(x uint64) (n int) {
	return sovDriver(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *ParseRequest) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ParseRequest: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ParseRequest: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Content", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Content = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Language", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Language = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Filename", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Filename = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Mode", wireType)
			}
			m.Mode = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Mode |= (Mode(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ParseResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ParseResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ParseResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Uast", wireType)
			}
			var byteLen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				byteLen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if byteLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + byteLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Uast = append(m.Uast[:0], dAtA[iNdEx:postIndex]...)
			if m.Uast == nil {
				m.Uast = []byte{}
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Language", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Language = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Errors", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Errors = append(m.Errors, &ParseError{})
			if err := m.Errors[len(m.Errors)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ParseError) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ParseError: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ParseError: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Text", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Text = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Version) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Version: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Version: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Version", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Version = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Build", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := types.StdTimeUnmarshal(&m.Build, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Manifest) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Manifest: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Manifest: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Name", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Name = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Language", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Language = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Aliases", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Aliases = append(m.Aliases, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Version", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Version == nil {
				m.Version = &Version{}
			}
			if err := m.Version.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Status", wireType)
			}
			m.Status = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Status |= (DevelopmentStatus(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Features", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= (uint64(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + intStringLen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Features = append(m.Features, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *VersionRequest) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: VersionRequest: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: VersionRequest: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *VersionResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: VersionResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: VersionResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Version", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Version == nil {
				m.Version = &Version{}
			}
			if err := m.Version.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *SupportedLanguagesRequest) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: SupportedLanguagesRequest: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: SupportedLanguagesRequest: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *SupportedLanguagesResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: SupportedLanguagesResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: SupportedLanguagesResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Languages", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthDriver
			}
			postIndex := iNdEx + msglen
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Languages = append(m.Languages, &Manifest{})
			if err := m.Languages[len(m.Languages)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipDriver(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if skippy < 0 {
				return ErrInvalidLengthDriver
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipDriver(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowDriver
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
			return iNdEx, nil
		case 1:
			iNdEx += 8
			return iNdEx, nil
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowDriver
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			iNdEx += length
			if length < 0 {
				return 0, ErrInvalidLengthDriver
			}
			return iNdEx, nil
		case 3:
			for {
				var innerWire uint64
				var start int = iNdEx
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return 0, ErrIntOverflowDriver
					}
					if iNdEx >= l {
						return 0, io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					innerWire |= (uint64(b) & 0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				innerWireType := int(innerWire & 0x7)
				if innerWireType == 4 {
					break
				}
				next, err := skipDriver(dAtA[start:])
				if err != nil {
					return 0, err
				}
				iNdEx = start + next
			}
			return iNdEx, nil
		case 4:
			return iNdEx, nil
		case 5:
			iNdEx += 4
			return iNdEx, nil
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
	}
	panic("unreachable")
}

var (
	ErrInvalidLengthDriver = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowDriver   = fmt.Errorf("proto: integer overflow")
)

func init() { proto.RegisterFile("driver.proto", fileDescriptorDriver) }

var fileDescriptorDriver = []byte{
	// 852 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x9c, 0x54, 0xcf, 0x6f, 0xe3, 0x44,
	0x14, 0x8e, 0xd3, 0x24, 0x4d, 0x5e, 0xd3, 0x5d, 0x33, 0x87, 0x95, 0x31, 0x28, 0x35, 0x91, 0x90,
	0xca, 0xa2, 0x75, 0x51, 0x38, 0xb1, 0x9c, 0x9c, 0xc6, 0xec, 0x06, 0x25, 0x69, 0xe4, 0xa4, 0x3d,
	0x70, 0xa9, 0x26, 0xc9, 0x8b, 0x6b, 0xad, 0xe3, 0x31, 0x9e, 0x71, 0xc4, 0x91, 0x03, 0xa7, 0x48,
	0x48, 0x7b, 0x47, 0x11, 0xfc, 0x39, 0x3d, 0xf2, 0x0f, 0xf0, 0xab, 0xfc, 0x23, 0xc8, 0x33, 0x76,
	0x23, 0xb4, 0xb0, 0xa9, 0xf6, 0x36, 0xcf, 0xdf, 0x7c, 0x7e, 0xdf, 0x7c, 0xef, 0x9b, 0x81, 0xe6,
	0x22, 0x09, 0xd6, 0x98, 0xd8, 0x71, 0xc2, 0x04, 0x23, 0x27, 0x3e, 0x8b, 0x5f, 0xf9, 0x76, 0x10,
	0xd9, 0xb3, 0x59, 0xb8, 0xe4, 0x37, 0x36, 0x5f, 0xbc, 0xb2, 0xd7, 0x1d, 0x85, 0xce, 0x59, 0x68,
	0x3e, 0xf3, 0x03, 0x71, 0x93, 0xce, 0xec, 0x39, 0x5b, 0x9d, 0xf9, 0xcc, 0x67, 0x67, 0x12, 0x99,
	0xa5, 0x4b, 0x59, 0xc9, 0x42, 0xae, 0x14, 0xc3, 0x3c, 0xf1, 0x19, 0xf3, 0x43, 0xdc, 0xed, 0x12,
	0xc1, 0x0a, 0xb9, 0xa0, 0xab, 0x58, 0x6d, 0x68, 0xff, 0xa4, 0x41, 0x73, 0x4c, 0x13, 0x8e, 0x1e,
	0x7e, 0x9b, 0x22, 0x17, 0xc4, 0x80, 0xc3, 0x39, 0x8b, 0x04, 0x46, 0xc2, 0xd0, 0x2c, 0xed, 0xb4,
	0xe1, 0x15, 0x25, 0x31, 0xa1, 0x1e, 0xd2, 0xc8, 0x4f, 0xa9, 0x8f, 0x46, 0x59, 0x42, 0xf7, 0x75,
	0x86, 0x2d, 0x83, 0x10, 0x23, 0xba, 0x42, 0xe3, 0x40, 0x61, 0x45, 0x4d, 0xbe, 0x80, 0xca, 0x8a,
	0x2d, 0xd0, 0xa8, 0x58, 0xda, 0xe9, 0xa3, 0xce, 0xc7, 0xf6, 0x9e, 0x23, 0xda, 0x43, 0xb6, 0x40,
	0x4f, 0x52, 0xda, 0x3f, 0x68, 0x70, 0x9c, 0xab, 0xe3, 0x31, 0x8b, 0x38, 0x12, 0x02, 0x95, 0x94,
	0x72, 0xa5, 0xad, 0xe9, 0xc9, 0xf5, 0x5b, 0x85, 0x9d, 0x43, 0x0d, 0x93, 0x84, 0x25, 0xdc, 0x38,
	0xb0, 0x0e, 0x4e, 0x8f, 0x3a, 0x9f, 0xee, 0x6d, 0x2f, 0xfb, 0xb9, 0x19, 0xc7, 0xcb, 0xa9, 0x6d,
	0x0b, 0x60, 0xf7, 0x35, 0x93, 0x20, 0xf0, 0xbb, 0xc2, 0x1e, 0xb9, 0x6e, 0x5f, 0xc3, 0xe1, 0x15,
	0x26, 0x3c, 0x60, 0x51, 0x66, 0xe0, 0x5a, 0x2d, 0x0b, 0x03, 0xf3, 0x92, 0x3c, 0x87, 0xea, 0x2c,
	0x0d, 0xc2, 0x85, 0x14, 0x79, 0xd4, 0x31, 0x6d, 0x35, 0x1c, 0xbb, 0x18, 0x8e, 0x3d, 0x2d, 0x86,
	0xd3, 0xad, 0xdf, 0xfe, 0x7e, 0x52, 0x7a, 0xfd, 0xc7, 0x89, 0xe6, 0x29, 0x4a, 0xfb, 0xfb, 0x32,
	0xd4, 0x87, 0x34, 0x0a, 0x96, 0xd9, 0x8c, 0x08, 0x54, 0xa4, 0xd3, 0xb9, 0x02, 0xe9, 0xf2, 0xdb,
	0x4c, 0x30, 0xe0, 0x90, 0x86, 0x01, 0xe5, 0xa8, 0x5c, 0x68, 0x78, 0x45, 0x49, 0xba, 0x3b, 0xb1,
	0x15, 0x29, 0xea, 0x74, 0xaf, 0x3f, 0xf9, 0x39, 0x77, 0xc7, 0xfa, 0x1a, 0x6a, 0x5c, 0x50, 0x91,
	0x72, 0xa3, 0x2a, 0x27, 0xdc, 0xd9, 0xfb, 0x8b, 0x1e, 0xae, 0x31, 0x64, 0xf1, 0x0a, 0x23, 0x31,
	0x91, 0x4c, 0x2f, 0xff, 0x83, 0xcc, 0x11, 0x52, 0x91, 0x26, 0xc8, 0x8d, 0x9a, 0x94, 0x7a, 0x5f,
	0xb7, 0x75, 0x78, 0x54, 0xf4, 0x56, 0x59, 0x6d, 0x5f, 0xc2, 0xe3, 0xfb, 0x2f, 0x79, 0x3e, 0xba,
	0xff, 0x76, 0xff, 0x5d, 0x0e, 0xd4, 0xfe, 0x00, 0xde, 0x9f, 0xa4, 0x71, 0xcc, 0x12, 0x81, 0x8b,
	0x41, 0xee, 0x21, 0x2f, 0x7a, 0x22, 0x98, 0xff, 0x05, 0xe6, 0xed, 0x5f, 0x40, 0xa3, 0x70, 0x9d,
	0x1b, 0x9a, 0x4c, 0xdc, 0x27, 0xfb, 0x03, 0x9f, 0xcf, 0xd5, 0xdb, 0x71, 0x9f, 0xfe, 0xac, 0x41,
	0x25, 0xbb, 0x08, 0xe4, 0x23, 0x68, 0xf6, 0xdc, 0xaf, 0x9c, 0xcb, 0xc1, 0xf4, 0x7a, 0x78, 0xd1,
	0x73, 0xf5, 0x92, 0xf9, 0x78, 0xb3, 0xb5, 0x8e, 0x7a, 0xb8, 0xa4, 0x69, 0x28, 0xe4, 0x96, 0x27,
	0x50, 0x1b, 0x39, 0xd3, 0xfe, 0x95, 0xab, 0x6b, 0x26, 0x6c, 0xb6, 0x56, 0x6d, 0x44, 0x45, 0xb0,
	0x46, 0xd2, 0x86, 0xe6, 0xd8, 0x73, 0xc7, 0xde, 0xc5, 0xb9, 0x3b, 0x99, 0xb8, 0x3d, 0xbd, 0x6c,
	0xea, 0x9b, 0xad, 0xd5, 0x1c, 0x27, 0x18, 0x27, 0x6c, 0x8e, 0x9c, 0xe3, 0x82, 0x7c, 0x08, 0x0d,
	0x67, 0x34, 0xba, 0x98, 0x3a, 0x53, 0xb7, 0xa7, 0x57, 0xcc, 0xe3, 0xcd, 0xd6, 0x6a, 0x38, 0x51,
	0xc4, 0x04, 0x15, 0xb8, 0xc8, 0xc6, 0x31, 0x71, 0x87, 0xce, 0x68, 0xda, 0x3f, 0xd7, 0xeb, 0x66,
	0x73, 0xb3, 0xb5, 0xea, 0x13, 0x5c, 0xd1, 0x48, 0x04, 0xf3, 0xa7, 0xbf, 0x69, 0xf0, 0xde, 0x1b,
	0x83, 0x24, 0xad, 0x4c, 0xee, 0xd5, 0x75, 0x7f, 0xe4, 0x9c, 0x4b, 0x45, 0x25, 0xc5, 0xea, 0x47,
	0x74, 0x2e, 0x35, 0xe5, 0xf8, 0x78, 0xe0, 0x8c, 0x46, 0xfd, 0xd1, 0x0b, 0x5d, 0x53, 0xf8, 0x38,
	0xa4, 0x51, 0x14, 0x44, 0xfe, 0x3d, 0xee, 0xb9, 0xce, 0x60, 0xfc, 0xd2, 0xd1, 0xcb, 0x39, 0x9e,
	0xa0, 0x13, 0xc6, 0x37, 0x94, 0x18, 0xd0, 0xc8, 0x70, 0x05, 0x1e, 0x98, 0x8d, 0xcd, 0xd6, 0xaa,
	0x2a, 0xe4, 0x09, 0xd4, 0x33, 0xa4, 0xeb, 0x4e, 0x1d, 0xbd, 0x62, 0xd6, 0x37, 0x5b, 0xab, 0xd2,
	0x45, 0x41, 0x89, 0x09, 0x90, 0x7d, 0x9f, 0x4c, 0x9d, 0xee, 0xc0, 0xd5, 0xab, 0xca, 0xa1, 0x89,
	0xa0, 0xb3, 0x10, 0x0b, 0x6c, 0xe8, 0x4c, 0x2f, 0x3d, 0x57, 0xaf, 0x29, 0x6c, 0x28, 0xf3, 0xd6,
	0x89, 0xa1, 0xd6, 0x93, 0x4f, 0x33, 0x59, 0x42, 0x55, 0x5e, 0x7f, 0xf2, 0xec, 0x61, 0x8f, 0x47,
	0x1e, 0x15, 0xd3, 0x7e, 0xe8, 0x76, 0x15, 0x9e, 0xce, 0xeb, 0x32, 0x80, 0x6a, 0xf9, 0x92, 0x71,
	0x41, 0x12, 0x38, 0x9e, 0x60, 0xb2, 0xc6, 0xa4, 0x78, 0x59, 0xce, 0x1e, 0x1c, 0xe5, 0x5c, 0xc0,
	0x67, 0x0f, 0x27, 0xe4, 0xf9, 0xfd, 0x51, 0x03, 0xf2, 0x66, 0xbc, 0xc9, 0xf3, 0xbd, 0x3f, 0xfa,
	0xdf, 0x0b, 0x63, 0x7e, 0xf9, 0x4e, 0x5c, 0xa5, 0xa7, 0xdb, 0xba, 0xfd, 0xab, 0x55, 0xba, 0xbd,
	0x6b, 0x69, 0xbf, 0xde, 0xb5, 0xb4, 0x3f, 0xef, 0x5a, 0xa5, 0x5f, 0xfe, 0x6e, 0x69, 0xdf, 0xd4,
	0x0b, 0xea, 0xac, 0x26, 0x57, 0x9f, 0xff, 0x13, 0x00, 0x00, 0xff, 0xff, 0xc6, 0x5d, 0x63, 0x41,
	0x46, 0x07, 0x00, 0x00,
}
